//Prefabs to use when populating the world
var cloud : Transform;
var pinwheel : Transform;
var ring : Transform;

//Values defining the world extends
var worldWidth = 100;
var worldHeight = 100;
var worldDepth = 100;

//The size of the pickup area, to keep rings closer to the center
var pickupWidth = 500;
var pickupDepth = 500;

//The density of the cloud groups
var density = 50;

/* At the start of the game populate the world with random elements. Does not respect static geo */
function Start () {
	var position;
	var x;
	var y;
	
	
	//Create all the clumps of clouds
    for (y = 0; y < 20; y++) 
    {
    	
    	position = Vector3(Random.Range(-worldWidth, worldWidth), Random.Range(50, worldHeight), Random.Range(-worldDepth, worldDepth));
    	var population = Random.Range(20, 50);
    	
        for (x = 0; x < population; x++) 
        {
        	var offset = new Vector3(Random.Range(-density, density), Random.Range(-density, density), Random.Range(-density, density));
        	
            var newCloud = Instantiate(cloud, position + offset, Quaternion.identity);
        }
    }
    
    //Create all the rings.
    for (y = 0; y < 30; y++) {
    	
    	position = Vector3(Random.Range(-pickupWidth, pickupWidth), Random.Range(-20, worldHeight), Random.Range(-pickupDepth, pickupDepth));
    	var ringCount = Random.Range(1, 10);
    	
    	var ringRotation = Vector3.up * Random.value;
    	
    	
        for (x = 0; x < ringCount; x++) 
        {
            var ring = Instantiate(ring, position, Quaternion.identity);
            ring.transform.Rotate(ringRotation * 360);
            ring.transform.Translate(Vector3.forward * 10.0 * x);
        }
    }
    
    //Create the pinwheels
    for (y = 0; y < 5; y++) 
    {
        for (x = 0; x < 5; x++) 
        {
        	
        	position = Vector3(Random.Range(-worldWidth, worldWidth), Random.Range(90, 150), Random.Range(-worldDepth, worldDepth));
            var newPinwheel = Instantiate(pinwheel, position, Quaternion.Euler(0, Random.Range(0, 360), 0));
        }
    }

} 