// The rate at which the rings shrink per second
var shrinkRate:float = 0.5;
// How many seconds the player has until a combo is broken
var comboWindow = 10.0;

// Global values for combo checking
private static var lastRingTime = -1.0;
private static var lastPitch = 0.8;

private var passed:boolean = false;

function OnTriggerEnter(collision : Collider)
{	
	passed = true;
	
	// Check if the player is on a combo streak, increaing pitch
	if ((Time.time - lastRingTime) < comboWindow)
	{
		lastPitch += 0.02; 
		lastPitch = Mathf.Min(lastPitch, 2.0);
		audio.pitch = lastPitch;
	}
	else
	{
		lastPitch = 0.8;	
		Debug.Log("COMBO BROKE");
	}
	
	// Update the last time a ring was passed for combo test
	lastRingTime = Time.time;	

	audio.Play();
	
	// Increment collected total so the tail knows when to grow.
	TailLogic.collected++;
}

function Update() {

	// If we have been passed, scale down and destory
	if (passed)
	{
		if (transform.localScale.x > 0.0)
		{
			transform.localScale -= Vector3.one * shrinkRate * Time.deltaTime;	
		}	
		else
		{
			Destroy (gameObject);
		}
	}
	
}