// The target we are following
var target : Transform;
// The distance in the x-z plane to the target
var distance = 1.0;
// How much we dampen
var rotationDamping = 3.0;

// The size to scale up to, out of 1.0
var size = 0.8;

private var currentSize = 0.0;

function Start () {
	transform.localScale = Vector3.zero;
}

function Update() {
	// Grow the segment out when it is first created	
	if (transform.localScale.x < size)
	{
		transform.localScale +=  Vector3.one * 0.2 * Time.deltaTime;	
	}
}

function Follow () {
	// Early out if we don't have a target
	if (!target)
		return;
	else
	{
		FollowTarget(target);	
	}
}

function FollowTarget (iTarget:Transform)  {
	transform.rotation = Quaternion.Lerp (transform.rotation, iTarget.rotation, rotationDamping * Time.deltaTime);
	transform.position = iTarget.position - transform.rotation * Vector3.forward * transform.localScale.x * distance;
}